# Class URL

java.lang.Object
com.codename1.io.URL

public class URL extends Object
This class provides a similar API to `URL` making it almost into a "drop in" replacement. It is placed in a different package because it is incompatible to `URL` by definition. It is useful in getting some simple code to work without too many changes

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `URL.HttpURLConnection`
  `class`
  `URL.URLConnection`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `URL(String url)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `getAuthority()`
  `int`
  `getDefaultPort()`
  `String`
  `getFile()`
  `String`
  `getHost()`
  `String`
  `getPath()`
  `int`
  `getPort()`
  `String`
  `getProtocol()`
  `String`
  `getQuery()`
  `String`
  `getUserInfo()`
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `URL.URLConnection`
  `openConnection()`
  `final InputStream`
  `openStream()`
  `boolean`
  `sameFile(URL u)`
  `String`
  `toExternalForm()`
  `String`
  `toString()`
  Returns a string representation of the object.
  `URI`
  `toURI()`

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### URL

    public URL(String url) throws URISyntaxException
    Throws:
      `URISyntaxException`

- ## Method Details

  - ### getQuery

    public String getQuery()

  - ### getPath

    public String getPath()

  - ### getUserInfo

    public String getUserInfo()

  - ### getAuthority

    public String getAuthority()

  - ### getPort

    public int getPort()

  - ### getDefaultPort

    public int getDefaultPort()

  - ### getProtocol

    public String getProtocol()

  - ### getHost

    public String getHost()

  - ### getFile

    public String getFile()

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### sameFile

    public boolean sameFile(URL u)

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`

  - ### toExternalForm

    public String toExternalForm()

  - ### toURI

    public URI toURI() throws URISyntaxException
    Throws:
      `URISyntaxException`

  - ### openConnection

    public URL.URLConnection openConnection() throws IOException
    Throws:
      `IOException`

  - ### openStream

    public final InputStream openStream() throws IOException
    Throws:
      `IOException`